> ## Documentation Index
> Fetch the complete documentation index at: https://docs.birrpay.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Payment Method - Confirm Intent

> Update a payment method with customer's payment method related information.



## OpenAPI

````yaml post /v2/payment-methods/{id}/confirm-intent
openapi: 3.0.3
info:
  title: BirrPay - API Documentation
  description: >

    ## Get started


    BirrPay provides a collection of APIs that enable you to process and manage
    payments.

    Our APIs accept and return JSON in the HTTP body, and return standard HTTP
    response codes.


    You can consume the APIs directly using your favorite HTTP/REST library.


    We have a testing environment referred to "sandbox", which you can setup to
    test API calls without

    affecting production data.

    Currently, our sandbox environment is live while our production environment
    is under development

    and will be available soon.

    You can sign up on our Dashboard to get API keys to access BirrPay API.


    ### Environment


    Use the following base URLs when making requests to the APIs:


    | Environment   |  Base URL                          |

    |---------------|------------------------------------|

    | Sandbox       | <https://sandbox.birrpay.io>   |

    | Production    | <https://api.birrpay.io>       |


    ## Authentication


    When you sign up on our [dashboard](https://app.birrpay.io) and create a
    merchant

    account, you are given a secret key (also referred as api-key) and a
    publishable key.

    You may authenticate all API requests with BirrPay server by providing the
    appropriate key in

    the request Authorization header.


    | Key             | 
    Description                                                                                 
    |

    |-----------------|-----------------------------------------------------------------------------------------------|

    | api-key         | Private key. Used to authenticate all API requests from
    your merchant server                  |

    | publishable key | Unique identifier for your account. Used to authenticate
    API requests from your app's client  |


    Never share your secret api keys. Keep them guarded and secure.
  contact:
    name: BirrPay Support
    url: https://birrpay.io
    email: support@birrpay.io
  license:
    name: Apache-2.0
  version: 0.1.0
servers:
  - url: https://sandbox.birrpay.io
    description: Sandbox Environment
security: []
tags:
  - name: Merchant Account
    description: Create and manage merchant accounts
  - name: Profile
    description: Create and manage profiles
  - name: Merchant Connector Account
    description: Create and manage merchant connector accounts
  - name: Payments
    description: Create and manage one-time payments, recurring payments and mandates
  - name: Refunds
    description: Create and manage refunds for successful payments
  - name: Mandates
    description: Manage mandates
  - name: Customers
    description: Create and manage customers
  - name: Payment Methods
    description: Create and manage payment methods of customers
  - name: Disputes
    description: Manage disputes
  - name: API Key
    description: Create and manage API Keys
  - name: Payouts
    description: Create and manage payouts
  - name: payment link
    description: Create payment link
  - name: Routing
    description: Create and manage routing configurations
  - name: Event
    description: Manage events
paths:
  /v2/payment-methods/{id}/confirm-intent:
    post:
      tags:
        - Payment Methods
      summary: Payment Method - Confirm Intent
      description: >-
        Update a payment method with customer's payment method related
        information.
      operationId: Confirm Payment Method Intent
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/PaymentMethodIntentConfirm'
        required: true
      responses:
        '200':
          description: Payment Method Intent Confirmed
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PaymentMethodResponse'
        '400':
          description: Invalid Data
      security:
        - api_key: []
components:
  schemas:
    PaymentMethodIntentConfirm:
      type: object
      required:
        - payment_method_data
        - payment_method_type
        - payment_method_subtype
      properties:
        customer_id:
          type: string
          description: The unique identifier of the customer.
          example: cus_y3oqhf46pyzuxjbcn2giaqnb44
          nullable: true
          maxLength: 64
          minLength: 1
        payment_method_data:
          $ref: '#/components/schemas/PaymentMethodCreateData'
        payment_method_type:
          $ref: '#/components/schemas/PaymentMethod'
        payment_method_subtype:
          $ref: '#/components/schemas/PaymentMethodType'
      additionalProperties: false
    PaymentMethodResponse:
      type: object
      required:
        - id
        - merchant_id
        - customer_id
        - payment_method_type
        - network_transaction_id
      properties:
        id:
          type: string
          description: The unique identifier of the Payment method
          example: 12345_pm_01926c58bc6e77c09e809964e72af8c8
        merchant_id:
          type: string
          description: Unique identifier for a merchant
          example: merchant_1671528864
        customer_id:
          type: string
          description: The unique identifier of the customer.
          example: 12345_cus_01926c58bc6e77c09e809964e72af8c8
          maxLength: 64
          minLength: 32
        payment_method_type:
          $ref: '#/components/schemas/PaymentMethod'
        payment_method_subtype:
          allOf:
            - $ref: '#/components/schemas/PaymentMethodType'
          nullable: true
        recurring_enabled:
          type: boolean
          description: >-
            Indicates whether the payment method supports recurring payments.
            Optional.
          example: true
          nullable: true
        created:
          type: string
          format: date-time
          description: >-
            A timestamp (ISO 8601 code) that determines when the payment method
            was created
          example: '2023-01-18T11:04:09.922Z'
          nullable: true
        last_used_at:
          type: string
          format: date-time
          description: >-
            A timestamp (ISO 8601 code) that determines when the payment method
            was last used
          example: '2024-02-24T11:04:09.922Z'
          nullable: true
        payment_method_data:
          allOf:
            - $ref: '#/components/schemas/PaymentMethodResponseData'
          nullable: true
        connector_tokens:
          type: array
          items:
            $ref: '#/components/schemas/ConnectorTokenDetails'
          description: The connector token details if available
          nullable: true
        network_token:
          allOf:
            - $ref: '#/components/schemas/NetworkTokenResponse'
          nullable: true
        storage_type:
          allOf:
            - $ref: '#/components/schemas/StorageType'
          nullable: true
        card_cvc_token_storage:
          allOf:
            - $ref: '#/components/schemas/CardCVCTokenStorageDetails'
          nullable: true
        network_transaction_id:
          type: string
          description: >-
            The network transaction ID provided by the card network during a
            Customer Initiated Transaction (CIT)

            when `setup_future_usage` is set to `off_session`.
    PaymentMethodCreateData:
      oneOf:
        - type: object
          required:
            - card
          properties:
            card:
              $ref: '#/components/schemas/CardDetail'
        - type: object
          required:
            - proxy_card
          properties:
            proxy_card:
              $ref: '#/components/schemas/ProxyCardDetails'
    PaymentMethod:
      type: string
      description: 'Indicates the type of payment method. Eg: ''card'', ''wallet'', etc.'
      enum:
        - card
        - card_redirect
        - pay_later
        - wallet
        - bank_redirect
        - bank_transfer
        - crypto
        - bank_debit
        - reward
        - real_time_payment
        - upi
        - voucher
        - gift_card
        - open_banking
        - mobile_payment
        - network_token
    PaymentMethodType:
      type: string
      description: >-
        Indicates the sub type of payment method. Eg: 'google_pay' & 'apple_pay'
        for wallets.
      enum:
        - ach
        - affirm
        - afterpay_clearpay
        - alfamart
        - ali_pay
        - ali_pay_hk
        - alma
        - amazon_pay
        - paysera
        - apple_pay
        - atome
        - bacs
        - bancontact_card
        - becs
        - benefit
        - bizum
        - blik
        - bluecode
        - boleto
        - bca_bank_transfer
        - bni_va
        - breadpay
        - bri_va
        - bhn_card_network
        - card_redirect
        - cimb_va
        - classic
        - credit
        - crypto_currency
        - cashapp
        - dana
        - danamon_va
        - debit
        - duit_now
        - efecty
        - eft
        - eps
        - flexiti
        - fps
        - evoucher
        - giropay
        - givex
        - google_pay
        - go_pay
        - gcash
        - ideal
        - interac
        - indomaret
        - klarna
        - kakao_pay
        - local_bank_redirect
        - mandiri_va
        - knet
        - mb_way
        - mobile_pay
        - momo
        - momo_atm
        - multibanco
        - online_banking_thailand
        - online_banking_czech_republic
        - online_banking_finland
        - online_banking_fpx
        - online_banking_poland
        - online_banking_slovakia
        - oxxo
        - pago_efectivo
        - permata_bank_transfer
        - open_banking_uk
        - pay_bright
        - payjustnow
        - paypal
        - paze
        - pix
        - pay_safe_card
        - przelewy24
        - prompt_pay
        - pse
        - qris
        - red_compra
        - red_pagos
        - samsung_pay
        - sepa
        - sepa_bank_transfer
        - sepa_guarenteed_debit
        - skrill
        - sofort
        - swish
        - touch_n_go
        - trustly
        - twint
        - upi_collect
        - upi_intent
        - upi_qr
        - vipps
        - viet_qr
        - venmo
        - walley
        - we_chat_pay
        - seven_eleven
        - lawson
        - mini_stop
        - family_mart
        - seicomart
        - pay_easy
        - local_bank_transfer
        - mifinity
        - open_banking_pis
        - direct_carrier_billing
        - instant_bank_transfer
        - instant_bank_transfer_finland
        - instant_bank_transfer_poland
        - revolut_pay
        - indonesian_bank_transfer
        - open_banking
        - network_token
    PaymentMethodResponseData:
      oneOf:
        - type: object
          required:
            - card
          properties:
            card:
              $ref: '#/components/schemas/CardDetailFromLocker'
    ConnectorTokenDetails:
      type: object
      description: >-
        Token information that can be used to initiate transactions by the
        merchant.
      required:
        - token
      properties:
        token:
          type: string
          description: >-
            A token that can be used to make payments directly with the
            connector.
          example: pm_9UhMqBMEOooRIvJFFdeW
        connector_token_request_reference_id:
          type: string
          description: The reference id sent to the connector when creating the token
          nullable: true
    NetworkTokenResponse:
      type: object
      required:
        - payment_method_data
      properties:
        payment_method_data:
          $ref: '#/components/schemas/NetworkTokenDetailsPaymentMethod'
    StorageType:
      type: string
      enum:
        - volatile
        - persistent
    CardCVCTokenStorageDetails:
      type: object
      required:
        - is_stored
      properties:
        is_stored:
          type: boolean
          description: Indicates whether the card cvc is stored or not
          example: true
        expires_at:
          type: string
          format: date-time
          description: >-
            A timestamp (ISO 8601 code) that determines expiry for stored card
            cvc token
          example: '2024-02-24T11:04:09.922Z'
          nullable: true
    CardDetail:
      type: object
      required:
        - card_number
        - card_exp_month
        - card_exp_year
        - card_holder_name
        - card_issuing_country
        - card_cvc
      properties:
        card_number:
          type: string
          description: Card Number
          example: '4111111145551142'
        card_exp_month:
          type: string
          description: Card Expiry Month
          example: '10'
        card_exp_year:
          type: string
          description: Card Expiry Year
          example: '25'
        card_holder_name:
          type: string
          description: Card Holder Name
          example: John Doe
        nick_name:
          type: string
          description: Card Holder's Nick Name
          example: John Doe
          nullable: true
        card_issuing_country:
          $ref: '#/components/schemas/CountryAlpha2'
        card_network:
          allOf:
            - $ref: '#/components/schemas/CardNetwork'
          nullable: true
        card_issuer:
          type: string
          description: Issuer Bank for Card
          nullable: true
        card_type:
          allOf:
            - $ref: '#/components/schemas/CardType'
          nullable: true
        card_cvc:
          type: string
          description: |-
            The CVC number for the card
            This is optional in case the card needs to be vaulted
          example: '242'
      additionalProperties: false
    ProxyCardDetails:
      type: object
      required:
        - card_number
        - card_exp_month
        - card_exp_year
        - card_holder_name
        - card_cvc
      properties:
        card_number:
          type: string
          description: Tokenized Card Number
          example: tok_sjfowhoejsldj
        card_exp_month:
          type: string
          description: Card Expiry Month
          example: '10'
        card_exp_year:
          type: string
          description: Card Expiry Year
          example: '25'
        bin_number:
          type: string
          description: First Six Digit of Card Number
          nullable: true
        last_four:
          type: string
          description: Last Four Digit of Card Number
          nullable: true
        card_issuer:
          type: string
          description: Issuer Bank for Card
          nullable: true
        card_network:
          allOf:
            - $ref: '#/components/schemas/CardNetwork'
          nullable: true
        card_type:
          type: string
          description: Card Type
          nullable: true
        card_issuing_country:
          type: string
          description: Issuing Country of the Card
          nullable: true
        nick_name:
          type: string
          description: Card Holder's Nick Name
          example: John Doe
          nullable: true
        card_holder_name:
          type: string
          description: Card Holder Name
          example: John Doe
        card_cvc:
          type: string
          description: |-
            The CVC number for the card
            This is optional in case the card needs to be vaulted
          example: '242'
    CardDetailFromLocker:
      type: object
      required:
        - saved_to_locker
      properties:
        issuer_country:
          allOf:
            - $ref: '#/components/schemas/CountryAlpha2'
          nullable: true
        last4_digits:
          type: string
          example: '4242'
          nullable: true
        expiry_month:
          type: string
          example: '10'
          nullable: true
        expiry_year:
          type: string
          example: '25'
          nullable: true
        card_holder_name:
          type: string
          example: John Doe
          nullable: true
        card_fingerprint:
          type: string
          example: fingerprint_12345
          nullable: true
        nick_name:
          type: string
          example: Card
          nullable: true
        card_network:
          allOf:
            - $ref: '#/components/schemas/CardNetwork'
          nullable: true
        card_isin:
          type: string
          example: '4567890'
          nullable: true
        card_issuer:
          type: string
          example: Issuer Bank
          nullable: true
        card_type:
          type: string
          example: Credit
          nullable: true
        saved_to_locker:
          type: boolean
          example: true
    NetworkTokenDetailsPaymentMethod:
      type: object
      properties:
        last4_digits:
          type: string
          example: '4242'
          nullable: true
        issuer_country:
          allOf:
            - $ref: '#/components/schemas/CountryAlpha2'
          nullable: true
        network_token_expiry_month:
          type: string
          example: '05'
          nullable: true
        network_token_expiry_year:
          type: string
          example: '27'
          nullable: true
        nick_name:
          type: string
          example: Card
          nullable: true
        card_holder_name:
          type: string
          example: John Doe
          nullable: true
        card_isin:
          type: string
          example: '16712672'
          nullable: true
        card_issuer:
          type: string
          example: Bank of America
          nullable: true
        card_network:
          allOf:
            - $ref: '#/components/schemas/CardNetwork'
          nullable: true
        card_type:
          type: string
          example: Credit
          nullable: true
        saved_to_locker:
          type: boolean
    CountryAlpha2:
      type: string
      enum:
        - AF
        - AX
        - AL
        - DZ
        - AS
        - AD
        - AO
        - AI
        - AQ
        - AG
        - AR
        - AM
        - AW
        - AU
        - AT
        - AZ
        - BS
        - BH
        - BD
        - BB
        - BY
        - BE
        - BZ
        - BJ
        - BM
        - BT
        - BO
        - BQ
        - BA
        - BW
        - BV
        - BR
        - IO
        - BN
        - BG
        - BF
        - BI
        - KH
        - CM
        - CA
        - CV
        - KY
        - CF
        - TD
        - CL
        - CN
        - CX
        - CC
        - CO
        - KM
        - CG
        - CD
        - CK
        - CR
        - CI
        - HR
        - CU
        - CW
        - CY
        - CZ
        - DK
        - DJ
        - DM
        - DO
        - EC
        - EG
        - SV
        - GQ
        - ER
        - EE
        - ET
        - FK
        - FO
        - FJ
        - FI
        - FR
        - GF
        - PF
        - TF
        - GA
        - GM
        - GE
        - DE
        - GH
        - GI
        - GR
        - GL
        - GD
        - GP
        - GU
        - GT
        - GG
        - GN
        - GW
        - GY
        - HT
        - HM
        - VA
        - HN
        - HK
        - HU
        - IS
        - IN
        - ID
        - IR
        - IQ
        - IE
        - IM
        - IL
        - IT
        - JM
        - JP
        - JE
        - JO
        - KZ
        - KE
        - KI
        - KP
        - KR
        - KW
        - KG
        - LA
        - LV
        - LB
        - LS
        - LR
        - LY
        - LI
        - LT
        - LU
        - MO
        - MK
        - MG
        - MW
        - MY
        - MV
        - ML
        - MT
        - MH
        - MQ
        - MR
        - MU
        - YT
        - MX
        - FM
        - MD
        - MC
        - MN
        - ME
        - MS
        - MA
        - MZ
        - MM
        - NA
        - NR
        - NP
        - NL
        - NC
        - NZ
        - NI
        - NE
        - NG
        - NU
        - NF
        - MP
        - 'NO'
        - OM
        - PK
        - PW
        - PS
        - PA
        - PG
        - PY
        - PE
        - PH
        - PN
        - PL
        - PT
        - PR
        - QA
        - RE
        - RO
        - RU
        - RW
        - BL
        - SH
        - KN
        - LC
        - MF
        - PM
        - VC
        - WS
        - SM
        - ST
        - SA
        - SN
        - RS
        - SC
        - SL
        - SG
        - SX
        - SK
        - SI
        - SB
        - SO
        - ZA
        - GS
        - SS
        - ES
        - LK
        - SD
        - SR
        - SJ
        - SZ
        - SE
        - CH
        - SY
        - TW
        - TJ
        - TZ
        - TH
        - TL
        - TG
        - TK
        - TO
        - TT
        - TN
        - TR
        - TM
        - TC
        - TV
        - UG
        - UA
        - AE
        - GB
        - UM
        - UY
        - UZ
        - VU
        - VE
        - VN
        - VG
        - VI
        - WF
        - EH
        - YE
        - ZM
        - ZW
        - US
    CardNetwork:
      type: string
      description: Indicates the card network.
      enum:
        - Visa
        - Mastercard
        - AmericanExpress
        - JCB
        - DinersClub
        - Discover
        - CartesBancaires
        - UnionPay
        - Interac
        - RuPay
        - Maestro
        - Star
        - Pulse
        - Accel
        - Nyce
    CardType:
      type: string
      enum:
        - credit
        - debit
  securitySchemes:
    api_key:
      type: apiKey
      in: header
      name: Authorization
      description: >-
        Format: `api-key=<api_key>`


        Use the API key created under your merchant account from the HyperSwitch
        dashboard. API key is used to authenticate API requests from your
        merchant server only. Don't expose this key on a website or embed it in
        a mobile application.

````